// =================================
// Widget

if (window.widget) {
	widget.onhide = onhide;
	widget.onshow = onshow;
	widget.onload = onload;
}

// =================================
// Vars

var ScrollingSpeed = [
	{name:'ScrollingSpeed_Slow', step:1, timer:150},
	{name:'ScrollingSpeed_Normal', step:1, timer:100},
	{name:'ScrollingSpeed_Fast', step:1, timer:50},
];

/*
timer - minutes
*/
var CheckUpdates = [
	{name:'CheckUpdates_Never', timer:-1},
	{name:'CheckUpdates_Everyday', timer:1140},
	{name:'CheckUpdates_Everyhour', timer:60},
	{name:'CheckUpdates_Every30mins', timer:30},
];


var ScrollDirectionUp = 1;
var ScrollDirectionDown = 2;

var xmlRequest;

/*
[ { title: x, url: x, description: x, new: x }, // channel
  [ { title: x, url: x, description: x, new: x }, // items
	 ... 
  ]		 
]

new: true | null/false
*/
var rssData;

// =================================
// Events Functions
function onshow() {
	smartStartScroll();
	smartStartCheckUpdatesTimer();

	fetchRSSIfNecessary();
	doCheckForUpdates();
}

function onhide() {
	stopScroll();
	stopCheckUpdatesTimer();
}

function onload() {
	/*
	smartStartScroll();
	smartStartCheckUpdatesTimer();

	fetchRSSIfNecessary();
	*/
	onshow();
}

function mousemove(event) {
	if (!flipShown)	{
		// fade in the flip widget
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ('animate();', 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event) {
	if (flipShown) {
		// fade in the flip widget
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ('animate();', 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


function mousemove_rsslist(event) {	
	stopScroll();
}

function mouseexit_rsslist(event) {

/*
TODO:
onmouseover, onmouseout events keep getting fired while moving in rsslist. should be only 1 time though?
*/
	// (10, 55) (190, 245)
	//debug(event.clientX + "," + event.clientY);
	
	if (event.clientX > 10 && event.clientX < 190 && event.clientY > 55 && event.clientY < 245) {
		return;
	}
	
	
	stopScrollAndAuto();
}

function showbackside(event) {
	var front = document.getElementById('front');
	var back = document.getElementById('behind');
	
	if (window.widget)
		widget.prepareForTransition('ToBack');
	onhide();
	
	front.style.display='none';
	back.style.display='block';
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	
	document.getElementById('fliprollie').style.display = 'none';
}

function playpauseMouseDown(event) {
	if (true == paused) {
		document.getElementById('playpausebutton').src = 'Images/btn-play-down.png';
	} else {
		document.getElementById('playpausebutton').src = 'Images/btn-pause-down.png';	
	}
}

function playpauseMouseUp(event) {
	if (true == paused) {
		startScroll();
	} else {
		stopScroll();
	}
	paused = !paused;
}

function topMouseDown(event) {
	document.getElementById('topbutton').src = 'Images/btn-top-down.png';
}

/*
0: top
1: bottom
*/
function gotoTopOrBottom(flag) {
	if (!rssData) {
		return;
	}
	
	var amount = -1;
	if (1 == flag) {
		amount = 1;
	}
	while (1) {
		clipTop += amount;
		clipBottom += amount;
		topper -= amount;
		if (clipTop < 0 || clipBottom > lyrheight)
		{
			break;
		}
		if (document.getElementById || document.all)
		{
				clipstring = 'rect('+clipTop+' '+clipWidth+' '+clipBottom+' 0)'
				thelayer.style.clip = clipstring;
				thelayer.style.top = topper;
		}
		else if (document.layers)
		{
				thelayer.style.clip.top = clipTop;
				thelayer.style.clip.bottom = clipBottom;
				thelayer.style.top = topper;
		}
	}
	
}

function topMouseUp(event) {
	gotoTopOrBottom(0);
	document.getElementById('topbutton').src = 'Images/btn-top.png';
}

function bottomMouseDown(event) {
	gotoTopOrBottom(1);
	document.getElementById('bottombutton').src = 'Images/btn-bottom-down.png';
}

function bottomMouseUp(event) {
	document.getElementById('bottombutton').src = 'Images/btn-bottom.png';
}

function upMouseDown(event) {
	document.getElementById('upbutton').src = 'Images/btn-up-down.png';
	startScroll(ScrollDirectionUp);
}

function upMouseUp(event) {
	document.getElementById('upbutton').src = 'Images/btn-up.png';
	stopScrollAndAuto();
}

function downMouseDown(event) {
	document.getElementById('downbutton').src = 'Images/btn-down-down.png';
	startScroll(ScrollDirectionDown);
}

function downMouseUp(event) {
	document.getElementById('downbutton').src = 'Images/btn-down.png';
	stopScrollAndAuto();
}


function doneMouseDown(event) {
	document.getElementById('done').src = 'Images/done_pressed.png';
}

function doneMouseUp(event) {
	if (window.widget) {
		// var rssurl = document.getElementById('rssurl-field').innerText;
		var rssurl = document.getElementById('rssurl-field').value; // why .value
		
		if (null != rssurl) {
			var oldrssurl = widget.preferenceForKey(identifiedKey('rssurl'));
			widget.setPreferenceForKey(rssurl, identifiedKey('rssurl'));
			
			if (oldrssurl != rssurl) {
				rssData = null;
				clearRSS();
				fetchRSS();
			}
		}
		
		//var scrolling = document.getElementById('autoscrolling-checkbox').checked;
		//widget.setPreferenceForKey(scrolling.toString(), identifiedKey('autoscrolling'));
		//widget.setPreferenceForKey(scrolling, identifiedKey('autoscrolling'));
		
		var colorNewArticles = document.getElementById('colornewarticles-checkbox').checked;
		widget.setPreferenceForKey(colorNewArticles, identifiedKey('colornewarticles'));		
		
		var speedPopup = document.getElementById ('scrollingspeed-popup');
		var c = speedPopup.options.length;
		for (var i = 0; i < c; i++) {
			if (true == speedPopup.options[i].selected) {
				widget.setPreferenceForKey(ScrollingSpeed[i].name, identifiedKey('scrollingspeed'));
				break;
			}
		}
	
		var checkUpdatesPopup = document.getElementById ('checkupdates-popup');
		var c = checkUpdatesPopup.options.length;
		for (var i = 0; i < c; i++) {
			if (true == checkUpdatesPopup.options[i].selected) {
				widget.setPreferenceForKey(CheckUpdates[i].name, identifiedKey('checkupdates'));
				
				if (0 == i) {
					stopCheckUpdatesTimer(); // never
					
				} else {
					smartStartCheckUpdatesTimer();
				}
				
				break;
			}
		}
		
	}	
	
	
	document.getElementById('done').src = 'Images/done.png';
	var front = document.getElementById('front');
	var back = document.getElementById('behind');

	if (window.widget)
		widget.prepareForTransition('ToFront');
			
	front.style.display='block';
	back.style.display='none';
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);	

	onshow();
}

function goURL(url) {
	if (window.widget) {
		widget.openURL(url.value);
	}
}

// =================================
// 'Check for updates' Functions

var check_updates_timer = null;
var timer_vector = 60000; // debug: 1000 (1 sec), release: 60000 (1 min)

function startCheckUpdatesTimer() {
	if (null != check_updates_timer) {
		return;
	}
	check_updates_timer = setInterval('doCheckForUpdates();', timer_vector);
	//debug(timer_vector);
}

function stopCheckUpdatesTimer() {
	if (null != check_updates_timer) {
		clearInterval(check_updates_timer);
		check_updates_timer = null;
	}
}

function smartStartCheckUpdatesTimer() {
	// Never
	if (0 == selectedCheckUpdates()) {

		return;
	}
	startCheckUpdatesTimer();
}

function doCheckForUpdates() {
	if (!window.widget)
		return;
	
	var lastFetchTime = widget.preferenceForKey(identifiedKey('fetchtime'));
	if (null == lastFetchTime) {
		fetchRSS();
		return;
	}
	
	var checkUpdatesTimer = CheckUpdates[selectedCheckUpdates()].timer;
	var dur = ((new Date).getTime() - lastFetchTime) / timer_vector;
	
	//debug(dur);
	if (dur > checkUpdatesTimer) {
		fetchRSS();
	}
}

// =================================
// Helper Functions

function filter_description(str) {
	var filter_div_element = document.getElementById('description_filter');
	filter_div_element.innerHTML = str;
	return filter_div_element.innerHTML;
}

function getLocalizedString (key) {
	try {
		return localizedStrings[key];
	} catch (ex) {}

	return key;
}

function identifiedKey(key) {
	return widget.identifier + '-' + key;
}

function initializeCheckUpdatesPopup() {
	var popup = document.getElementById ('checkupdates-popup');
	var selectedTimer = selectedCheckUpdates();
	var c = CheckUpdates.length;
	for (var i = 0; i < c; i++)	{
		var element = document.createElement('option');
		element.innerText = getLocalizedString(CheckUpdates[i].name);
				
		if (i == selectedTimer) {
			element.selected = true;
		}
		
		popup.appendChild(element);
	}
}

function initializeScrollingSpeedPopup() {
	var speedPopup = document.getElementById ('scrollingspeed-popup');
	var selectedSpeed = selectedScrollingSpeed();
	var c = ScrollingSpeed.length;
	
	for (var i = 0; i < c; i++) {
		var element = document.createElement('option');
		element.innerText = getLocalizedString(ScrollingSpeed[i].name);
		
		
		if (i == selectedSpeed) {
			element.selected = true;
		}
		
		speedPopup.appendChild (element);
	}
}

// feed:// -> http://
function safeURL(url) {
	return url.replace(/^feed:\/\//, "http://")
}

function fetchRSSIfNecessary() {
	if (!rssData) {
		fetchRSS();
	}
}

function fetchRSS() {
	/*
	if (window.widget) {
		widget.setPreferenceForKey((new Date).getTime(), identifiedKey('fetchtime'));
	}
	*/
	
	var rssURL = widget.preferenceForKey(identifiedKey('rssurl'));
	if (null == rssURL) {
		// TODO
		return;
	}

	loadXMLDoc(rssURL);
}

function outputStatus(status) {
	if (null == status) {
		return;
	}
	if ("" == status) {
		document.getElementById('status').innerText = status;
		return;
	}
	
	document.getElementById('status').innerText = status + " (" + getLocalizedString('ClickForHelp') + ")";
}

function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"font-family: monospace; " +
										"border: solid black 3px; " +
										"position: absolute;top:10px;" +
										"padding: 10px;" + 
										"color: black;");

		// broken in Tiger 323, document.body is null
		// document.body.appendChild(debug.box);
		document.appendChild(debug.box);
		
		debug.box.innerHTML = "<h1 style='text-align:center'>Debug Output</h1>";
	}
	
	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}


// retrieve text of an XML document element, including
// elements using namespaces
function getElementTextNS(prefix, local, parentElem, index) {
  var result = parentElem.getElementsByTagName(local)[index];
  
  if (!result) {
  	result = parentElem.getElementsByTagNameNS("*", local)[index];
  }

  if (!result) {
    return "";
  }

  // get text, accounting for possible
  // whitespace (carriage return) text nodes
  var elementText = '';
  if (result.childNodes.length > 1) {
    elementText = result.childNodes[1].nodeValue;
  } else if (result.childNodes.length > 0) {
    elementText = result.firstChild.nodeValue;
  }

  if (!elementText) {
    elementText= '';
    return elementText;  
  }
  
  if ('object' == typeof(elementText)) {
    elementText= '';
  }

  if ('' == elementText) {
    elementText = result.innerText; // doesn't work, so we may have empty string
  }
  
  return elementText;
}

function getElementAttribute(prefix, local, attribute, parentElem, index) {
    var result = parentElem.getElementsByTagName(local)[index];
    
    if (result) {
		return result.getAttribute(attribute);
    } else {
        return "n/a";
    }
}

// =================================
// Accessor Functions

// return: index of array ScrollingSpeed
function selectedScrollingSpeed() {
	var selectedSpeed = 1; // ScrollingSpeed_Normal
	
	if (!window.widget)
		return selectedSpeed;
		
	var storedValue = widget.preferenceForKey(identifiedKey('scrollingspeed'));
	if (!storedValue) {	
		return selectedSpeed;
	}

	var c = ScrollingSpeed.length;			
	for (var i = 0; i < c; i++)	{
		if (storedValue == ScrollingSpeed[i].name) {
			selectedSpeed = i;
			break;				
		}
	}
	
	return selectedSpeed;
}

// return: index of array ScrollingSpeed
function selectedCheckUpdates() {
	var selectedTimer = 1; // Every day
	
	if (!window.widget)
		return selectedTimer;
		
	var storedValue = widget.preferenceForKey(identifiedKey('checkupdates'));
	if (!storedValue) {	
		return selectedTimer;
	}
	
	var c = CheckUpdates.length;			
	for (var i = 0; i < c; i++)	{
		if (storedValue == CheckUpdates[i].name) {
			selectedTimer = i;
			break;				
		}
	}
	
	return selectedTimer;
}

function selectedAutoScrolling() {
	return true;
	/*
	var autoScrolling = true; 
	
	if (null == window.widget)
		return autoScrolling;
		
	var storedValue = widget.preferenceForKey(identifiedKey('autoscrolling'));
	if (null == storedValue)
		return autoScrolling;
		
	//return parseInt(storedValue);
	return storedValue;
	*/
}

function selectedColorNewArticles() {
	var colorNewArticles = false; 
	
	if (null == window.widget)
		return colorNewArticles;
		
	var storedValue = widget.preferenceForKey(identifiedKey('colornewarticles'));
	if (null == storedValue)
		return colorNewArticles;
		
	//return parseInt(storedValue);
	return storedValue;
}

function selectedRSSURL() {
	var rssURL = ''; 

	if (!window.widget)
		return rssURL;
		
	var storedValue = widget.preferenceForKey(identifiedKey('rssurl'));
	if (!storedValue)
		return rssURL;

	return storedValue;
}

// =================================
// UI Related
function displayRSSTitle(title, url) {
	var titleElement = document.getElementById('title-url');
	if (null != title) {
		titleElement.innerText = title;
	}
	
	if (null != url) {
		titleElement.value = url;	
	}
}

function initializeHTML() {

	// font
	displayRSSTitle(getLocalizedString('RSSBean'), null);
	
	// back
	if (window.widget) {
		var rssurl = widget.preferenceForKey(identifiedKey('rssurl'));
		if (null != rssurl) {
		 	document.getElementById('rssurl-field').innerText = rssurl;
		}
	}
	
 	document.getElementById('rssurl-label').innerText = getLocalizedString('RSS Feed:');		
 	 	
 	//document.getElementById('autoscrolling-label').innerText = getLocalizedString('Automatic scrolling'); 	
 	//document.getElementById('autoscrolling-checkbox').checked = selectedAutoScrolling();
 	
 	document.getElementById('colornewarticles-label').innerText = getLocalizedString('Color new articles');	
 	document.getElementById('colornewarticles-checkbox').checked = selectedColorNewArticles(); 	
 	
 	document.getElementById('scrollingspeed-label').innerText = getLocalizedString('Scrolling speed:');
 	document.getElementById('checkupdates-label').innerText = getLocalizedString('Check for updates:');		 	
 			 	
 	initializeScrollingSpeedPopup();
 	initializeCheckUpdatesPopup();

}


// =================================
// Flip, Animation Functions

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time - animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}

// duplicated, to do later
var fetchingAnimation = {timer: null, alphaNow:1.0, up:false, duration:1000, start:null};

function fetchAnimationTimer() {
	var time = (new Date).getTime();
	var fraction;
	
	if (fetchingAnimation.up)
		fraction = (time - fetchingAnimation.start) / fetchingAnimation.duration;
	else
		fraction = 1.0 - (time - fetchingAnimation.start) / fetchingAnimation.duration;
	
	fetchingAnimation.alphaNow = fraction;
	
	if (fetchingAnimation.alphaNow > 1.0)
	{
		fetchingAnimation.start = time;
		fetchingAnimation.alphaNow = 1.0;
		fetchingAnimation.up = false;
	}
	else if (fetchingAnimation.alphaNow < 0.0)
	{
		fetchingAnimation.start = time;
		fetchingAnimation.alphaNow = 0.0;
		fetchingAnimation.up = true;
	}
	
    var sine = Math.sin((Math.PI/2.0) * fetchingAnimation.alphaNow);

    fetchingAnimation.alphaNow = sine * sine;
    
    document.getElementById('dot').style.opacity = fetchingAnimation.alphaNow;
}

function startFetchingAnimation() {
	if (fetchingAnimation.timer != null)
	{
		clearInterval (fetchingAnimation.timer);
		fetchingAnimation.timer = null;
	}
	
	fetchingAnimation.up = false;
	fetchingAnimation.alphaNow = 1.0;
	fetchingAnimation.start = (new Date).getTime() - 60;
	fetchingAnimation.timer = setInterval ('fetchAnimationTimer();', 60);
	var dot = document.getElementById('dot');
	dot.style.opacity = '1.0';
	dot.style.display = 'inline';
}

function endFetchingAnimation()
{
	if (fetchingAnimation.timer != null)
	{
		clearInterval (fetchingAnimation.timer);
		fetchingAnimation.timer = null;
	}
	
	document.getElementById('dot').style.display = 'none';
}


// =================================
// Scrolling Function
// Copied from quirksmode.org

var currentScrollDirection = ScrollDirectionDown;
var currentAutoScrollDirection = ScrollDirectionDown;
var paused = false;

function getObj(name)
{
	if (document.getElementById)
	{
	    this.obj = document.getElementById(name);
	    this.style = document.getElementById(name).style;
	}
	else if (document.all)
	{
	    this.obj = document.all[name];
	    this.style = document.all[name].style;
	}
	else if (document.layers)
	{
	    this.obj = document.layers[name];
	    this.style = document.layers[name];
	}
}

var clipTop;
var clipWidth;
var clipBottom;
var topper;
var lyrheight;
var time, resetTime, amount,theTime,theHeight;

function initScroll()
{
	//debug(0);
	clipTop = 0;
	clipWidth = 190;
	clipBottom = 190;
	topper = 55;
	lyrheight = 0;
	currentScrollDirection = ScrollDirectionDown;
	currentAutoScrollDirection = ScrollDirectionDown;

	var x = new getObj('rss-list');
	if (document.layers)
	{
		lyrheight = x.style.clip.bottom;
		lyrheight += 20;
		x.style.clip.top = clipTop;
		x.style.clip.left = 0;
		x.style.clip.right = clipWidth;
		x.style.clip.bottom = clipBottom;
	}
	else if (document.getElementById || document.all)
	{
		lyrheight = x.obj.offsetHeight;
		x.style.clip = 'rect('+clipTop+' '+clipWidth+' '+clipBottom+' 0)'
	}
}

function resetScroll() {
	if (ScrollDirectionUp == currentScrollDirection) {
		currentAutoScrollDirection = ScrollDirectionDown;
	} else {
		currentAutoScrollDirection = ScrollDirectionUp;
	}
	
	startScroll(currentAutoScrollDirection);
}

function scrollayer(layername,amt,tim)
{
	thelayer = new getObj(layername);
	if (!thelayer) return;
	amount = amt;
	theTime = tim;
	realscroll();
}

function realscroll()
{
	clipTop += amount;
	clipBottom += amount;
	topper -= amount;
	if (clipTop < 0 || clipBottom > lyrheight)
	{
	        clipTop -= amount;
	        clipBottom -= amount;
	        topper += amount;
			
			resetTime = setTimeout('resetScroll()', 3000);	
	        return;
	}
	if (document.getElementById || document.all)
	{
	        clipstring = 'rect('+clipTop+' '+clipWidth+' '+clipBottom+' 0)'
	        thelayer.style.clip = clipstring;
	        thelayer.style.top = topper;
	}
	else if (document.layers)
	{
	        thelayer.style.clip.top = clipTop;
	        thelayer.style.clip.bottom = clipBottom;
	        thelayer.style.top = topper;
	}
	
	time = setTimeout('realscroll()',theTime);
}

function stopScroll()
{
	if (time) clearTimeout(time);
	if (resetTime) clearTimeout(resetTime);
	
	// update playpause button
	document.getElementById('playpausebutton').src = 'Images/btn-play.png';
}

function stopScrollAndAuto()
{
	stopScroll();
	if (true == selectedAutoScrolling() && false == paused) {
		startScroll(currentAutoScrollDirection);
	}
}

function startScroll(dirction) {
	stopScroll();
	
	currentScrollDirection = dirction;
	
	var speed = selectedScrollingSpeed();
	var step = ScrollingSpeed[speed].step;
	var timer = ScrollingSpeed[speed].timer;

	//debug(speed + '-' + step + '-' + timer);
	
	if (ScrollDirectionUp == dirction) {
		scrollayer('rss-list', -step, timer);

	} else {
		scrollayer('rss-list', step, timer);

	}

	// update playpause button
	document.getElementById('playpausebutton').src = 'Images/btn-pause.png';
	
}

function smartStartScroll(direction) {
	if (false == selectedAutoScrolling()) {
		return;
	}
	
	if (true == paused) {
		return;	
	}
	
	startScroll(direction);
}

// =================================
// XMLHttpRequest

function loadXMLDoc(url) {

	 xmlRequest = new XMLHttpRequest();
	 
	 xmlRequest.overrideMimeType('text/xml');
	 xmlRequest.onreadystatechange = processReqChange;
	 
	 xmlRequest.open("GET", safeURL(url), true);
	 xmlRequest.setRequestHeader("Cache-Control", "no-cache");

	 xmlRequest.send(null);
}

function processReqChange() {	
	if (null == xmlRequest.readyState) {
	    //outputStatus('readyState is null');
		return;
	}
	
	if (4 != xmlRequest.readyState) {
		//outputStatus(getLocalizedString('Loading...'));
		startFetchingAnimation();
		return;
	}
	endFetchingAnimation();

	// debug(xmlRequest.status);
	
	if (xmlRequest.status == 200) {	
		stopScroll();
		buildRSS();
		smartStartScroll();

		if (window.widget) {
			widget.setPreferenceForKey((new Date).getTime(), identifiedKey('fetchtime'));
		}
		
	 } else {
	 	if (null == xmlRequest.status) {
	 		//outputStatus('status is null');
	 		return;
	 	}

		outputStatus(getLocalizedString('Failed:') + ' ' + xmlRequest.status); 	
	 }
}

function buildRSS() {
    if (null == xmlRequest.responseXML) {
    	outputStatus('responseXML is empty');
    	return;
    }
	
    while (1) {
		if (true == buildRSSData_RSS20(xmlRequest.responseXML)) {
			break;			
		} else if (true == buildRSSData_RSS10(xmlRequest.responseXML)) {
			break;			
		} else if (true == buildRSSData_ATOM(xmlRequest.responseXML)) {
			break;
		}
    	
		outputStatus(getLocalizedString('Unknown Feed')); 	
    	return;
    }
		
	clearRSS();
	displayRSS();
	initScroll(); 	// rebuild scrolling	
}

function clearRSS() {
	displayRSSTitle(getLocalizedString('RSSBean'), null);

    var rsslist = document.getElementById("rss-list-ul");
    while (rsslist.childNodes.length > 0) {
        rsslist.removeChild(rsslist.childNodes[0]);
    }
    
}

function displayRSS() {
	var channelTitle = rssData[0]['title'];
	var channelURL = rssData[0]['url'];
	
	displayRSSTitle(channelTitle, channelURL);
	
	var items = rssData[1];
	var count = items.length;
	
	for (var i = 0; i < count; i++) {
		displayItem(items[i]);
	}
}

function displayItem(item) {
	var rsslist = document.getElementById ('rss-list-ul');

	var itemTitle = filter_description(item['title']);
	var itemURL = item['url'];
	var itemDescription = filter_description(item['description']);
	var itemNewFlag = item['new'];
	
	var aElement = document.createElement('a');
	var liElement = document.createElement('li');

	aElement.href = '#';
	aElement.onclick = function() {goURL(this);}
	aElement.innerText = itemTitle;
	aElement.value = itemURL;
	aElement.title = itemDescription;
	
	if (true == selectedColorNewArticles() && true == itemNewFlag) {
		aElement.className = 'newitem';	
	}
	
	liElement.appendChild(aElement);
	rsslist.appendChild(liElement);	

}

function fillNewFlagForRSSData(newData, oldData) {
	if (null == newData || null == oldData) {
		return;
	}
	
	var newDataItems = newData[1];
	var oldDataItems = oldData[1];

	var count = newDataItems.length;

	for (var i = 0; i < count; i++) {
		if (null == findItemForUIDInRSSData(newDataItems[i]['url'], oldData)) {
			newDataItems[i]['new'] = true;
		}
	}
	
}

function findItemForUIDInRSSData(uid, rssData) {
	var rssDataItems = rssData[1];
	var count = rssDataItems.length;
	
	for (var i = 0; i < count; i++) {
		if (uid == rssDataItems[i]['url']) {
			return rssDataItems[i];
		}
	}
	return null;
}

// RSS 2.0
function buildRSSData_RSS20(xml) {
	var rssElements = xml.getElementsByTagName('rss');
	if (null == rssElements || null == rssElements[0]) {
		return false;
	}
	
	var rssVersion = rssElements[0].getAttribute('version');
	if (null == rssVersion || rssVersion < 2.0) {
		return false;
	}
	
    var channelElements = xml.getElementsByTagName('channel');
    if (null == channelElements || null == channelElements[0]) {
    	return false;
    }
    
    var channelElement = channelElements[0];
    if (null == channelElement) {
    	return false;
    }
    
    var newRSSData = new Array();
    var buildResult = false;
    
    while (1) {
    	// channel
    	var channelData = new Array();
    	channelData['title'] = getElementTextNS('', 'title', channelElement, 0);
    	channelData['url'] = getElementTextNS('', 'link', channelElement, 0);

    	newRSSData[0] = channelData;
    	
    	// items
    	var itemsData = new Array();
    	newRSSData[1] = itemsData;
    	
		var itemElements = channelElement.getElementsByTagName('item');
		if (null == itemElements) {
			break;
		}
				
		var count = itemElements.length;
		for (var i = 0; i < count; i++) {
			var itemElement = itemElements[i];
			var itemTitle = getElementTextNS('', 'title', itemElement, 0);
			var itemURL = getElementTextNS('', 'link', itemElement, 0);
			var itemDescription = getElementTextNS('', 'description', itemElement, 0);
			
			var itemData = new Array();
			itemData['title'] = itemTitle;
			itemData['url'] = itemURL;
			itemData['description'] = itemDescription;
			
			itemsData[i] = itemData;
		}
    	
    	buildResult = true;
    	break;
    }
	
	if (true == buildResult) {
		// rssData = null;
		fillNewFlagForRSSData(newRSSData, rssData);
		rssData = newRSSData;
		return true;
	}

	newRSSData = null;
	return false;
}

// RSS 1.0
function buildRSSData_RSS10(xml) {
	var rssElements = xml.getElementsByTagName('RDF');
	if (null == rssElements || null == rssElements[0]) {
		// By Michael D. Fischer
		// Added new condition here to handle rss .91 feeds
		// or feeds (of which there are many) that do not use the RDF tag
        rssElements = xml.getElementsByTagName('rss');
        if (null == rssElements || null == rssElements[0]) {
			return false;
        }
	}

	var rssElement = rssElements[0];
    var channelElements = rssElement.getElementsByTagName('channel');
    if (null == channelElements || null == channelElements[0]) {
    	return false;
    }
    
    var channelElement = channelElements[0];
    if (null == channelElement) {
    	return false;
    }
    
    var newRSSData = new Array();
    var buildResult = false;
    
    while (1) {
    	// channel
    	var channelData = new Array();
    	channelData['title'] = getElementTextNS('', 'title', channelElement, 0);
    	channelData['url'] = getElementTextNS('', 'link', channelElement, 0);

    	newRSSData[0] = channelData;
    	
    	// items
    	var itemsData = new Array();
    	newRSSData[1] = itemsData;
    	
		var itemElements = rssElement.getElementsByTagName("item");
		if (null == itemElements) {
			break;
		}
				
		var count = itemElements.length;
		for (var i = 0; i < count; i++) {
			var itemElement = itemElements[i];
			var itemTitle = getElementTextNS('', 'title', itemElement, 0);
			var itemURL = getElementTextNS('', 'link', itemElement, 0);
			var itemDescription = getElementTextNS('', 'description', itemElement, 0);
			
			var itemData = new Array();
			itemData['title'] = itemTitle;
			itemData['url'] = itemURL;
			itemData['description'] = itemDescription;
			
			itemsData[i] = itemData;
		}
    	
    	buildResult = true;
    	break;
    }
	
	if (true == buildResult) {
		// rssData = null;
		fillNewFlagForRSSData(newRSSData, rssData);		
		rssData = newRSSData;
		return true;
	}

	newRSSData = null;
	return false;
}

function buildRSSData_ATOM(xml) {
	var rssElements = xml.getElementsByTagName('feed');
	if (null == rssElements || null == rssElements[0]) {
		return false;
	}

	var rssElement = rssElements[0];

    var newRSSData = new Array();
    var buildResult = false;
	
   	// channel
   	var channelData = new Array();
   	channelData['title'] = getElementTextNS('', 'title', rssElement, 0);
	channelData['url'] = getElementAttribute('', 'link', 'href', rssElement, 0);   	
   	
   	newRSSData[0] = channelData;
	    
    while (1) {    	
    	// items
    	var itemsData = new Array();
    	newRSSData[1] = itemsData;
    	
		var itemElements = xml.getElementsByTagName("entry");
		if (null == itemElements) {
			break;
		}
				
		var count = itemElements.length;
		for (var i = 0; i < count; i++) {
			var itemElement = itemElements[i];
			var itemTitle = getElementTextNS('', 'title', itemElement, 0);
			var itemURL = getElementAttribute('', 'link', 'href', itemElement, 0);
			var itemDescription = getElementTextNS('', 'summary', itemElement, 0);
			
			var itemData = new Array();
			itemData['title'] = itemTitle;
			itemData['url'] = itemURL;
			itemData['description'] = itemDescription;
			
			itemsData[i] = itemData;
		}
    	
    	buildResult = true;
    	break;
    }
	
	if (true == buildResult) {
		// rssData = null;
		fillNewFlagForRSSData(newRSSData, rssData);
		rssData = newRSSData;
		return true;
	}

	newRSSData = null;
	return false;
}

// debug
//fetchRSS();
//loadXMLDoc('http://127.0.0.1/~Xia/albums.xml');


